package logic

import (
	"context"

	"juwan-backend/app/order/rpc/internal/models/orderstatelogs"
	"juwan-backend/app/order/rpc/internal/svc"
	"juwan-backend/app/order/rpc/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetOrderStateLogsByIdLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetOrderStateLogsByIdLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetOrderStateLogsByIdLogic {
	return &GetOrderStateLogsByIdLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetOrderStateLogsByIdLogic) GetOrderStateLogsById(in *pb.GetOrderStateLogsByIdReq) (*pb.GetOrderStateLogsByIdResp, error) {
	item, err := l.svcCtx.OrderModelsRO.OrderStateLogs.Query().
		Where(orderstatelogs.IDEQ(in.Id)).
		Only(l.ctx)
	if err != nil {
		return nil, err
	}

	return &pb.GetOrderStateLogsByIdResp{OrderStateLogs: toPBOrderStateLog(item)}, nil
}
